import 'package:flutter/cupertino.dart';
import 'package:riverpod_annotation/riverpod_annotation.dart';
import 'package:shared/utils/log_utils.dart';

import '../../../respository/common_newsfeed.dart';
import '../my_follow/my_follow_vm.dart';
import '../my_follower/my_follower_vm.dart';
import 'item_following.dart';

part 'item_following_vm.g.dart';


Map<String, dynamic> MyFollowingType = {
  "isFollowType": '1',
  "isFollowerType": '2',
};

@riverpod
class ItemFollowingVm extends _$ItemFollowingVm {
  late CommonNewsFeedRespository commonNewsFeedRespositoryInstance;
  @override
  build(){
    // 引入数据仓库
    commonNewsFeedRespositoryInstance = ref.read(commonNewsFeedRespositoryProvider);
    final state = {};
    Log.d("--------------------------build---------------------");
    return state;
  }

  // 关注/取消关注
  Future<bool> handlerFollow(BuildContext? context, int to_user_id, bool isFollow, String itemType) async{
    Log.d("点击了 关注");
    try {
      final result = await commonNewsFeedRespositoryInstance.handlerFollowOrCancel({
        "to_user_id": to_user_id,
      });
      if(result.isSuccess){
        if(itemType == MyFollowingType['isFollowType']){
          // 删除 my_follow_list 中 id 为 to_user_id 的item
          final myFollowVm = ref.read(myFollowVmProvider.notifier);
          myFollowVm.softDeleteItem(to_user_id);
        }else if(itemType == MyFollowingType['isFollowerType']){
          // final myFlowerVm = ref.read(myFollowerVmProvider.notifier);
        }
        return true;
      }else {
        return false;
      }
    }catch(error){
      Log.d("error: $error");
      return false;
    }
  }
}