import 'package:plugin_basic/provider/user_config/user_config_service.dart';
import 'package:plugin_platform/http/dio/dio_cancelable_mixin.dart';
import 'package:riverpod_annotation/riverpod_annotation.dart';
import 'main_state.dart';

part 'main_view_model.g.dart';

@riverpod
class MainViewModel extends _$MainViewModel with DioCancelableMixin {
  @override
  MainState build() {
    final state = MainState();

    registerCancellation();

    return state;
  }

  /// 获取用户信息
  void fetchUserInfo() {
    UserConfigService.getInstance().refreshUserInfo();
  }

}
