
import 'package:cpt_property/modules/news_detail/property_news_detail_vm.dart';
import 'package:cs_resources/generated/l10n.dart';
import 'package:flutter/material.dart';
import 'package:auto_route/auto_route.dart';
import 'package:flutter_hooks/flutter_hooks.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'package:plugin_basic/widget/webview_page.dart';
import 'package:router/ext/auto_router_extensions.dart';

import '../../router/page/property_page_router.dart';

//协议页面，也是详情页面的第一个页面入口，内部可以请求详情数据和选项数据
@RoutePage()
class PropertyNewsDetailPage extends HookConsumerWidget {
  final String type;

  const PropertyNewsDetailPage({Key? key, @PathParam() required this.type}) : super(key: key);

  //启动当前页面
  static void startInstance({BuildContext? context, required String formType}) {
    if (context != null) {
      context.router.push(const PropertyNewsPageRoute());
    } else {
      appRouter.push(const PropertyNewsPageRoute());
    }
  }

  @override
  Widget build(BuildContext context, WidgetRef ref) {
    final vm = ref.read(propertyNewsDetailVmProvider.notifier);
    final state = ref.watch(propertyNewsDetailVmProvider);
    useEffect(() {
      // 组件挂载时执行 - 执行接口请求
      // 组件挂载时执行 - 执行接口请求
      Future.microtask(() => vm.initPageData());
      return () {
        // 组件卸载时执行
      };
    }, []);

    return state.detailData != null
        ? WebViewPage(
      showAppbar: true,
      initialUrl: state.detailData?['detail_url'],
      arguments: {'title': state.detailData?['title']},
    ): const SizedBox.shrink();
  }
}
