import 'package:auto_route/auto_route.dart';
import 'package:flutter/material.dart';
import 'package:router/ext/auto_router_extensions.dart';
import 'package:router/path/router_path.dart';

import '../../modules/services/services_page.dart';
import '../../modules/services_detail/services_detail_page.dart';
import '../../modules/services_list/services_list_page.dart';
import '../../modules/services_contact/services_contact_page.dart';
part 'services_page_router.gr.dart';

/*\
 * Form模块的路由
 */
@AutoRouterConfig(replaceInRouteName: 'Page|Screen,PageRoute')
class ServicesPageRouter extends _$ServicesPageRouter {
  @override
  List<AutoRoute> get routes => [

    CustomRoute(page: ServicesPageRoute.page, path: RouterPath.services, transitionsBuilder: applySlideTransition),

    CustomRoute(
            page: ServicesListPageRoute.page,
            path: RouterPath.servicesList,
            transitionsBuilder: applySlideTransition),

    CustomRoute(
            page: ServicesDetailPageRoute.page,
            path: RouterPath.servicesDetail,
            transitionsBuilder: applySlideTransition),
            CustomRoute(
            page: ServicesContactPageRoute.page,
            path: RouterPath.servicesContact,
            transitionsBuilder: applySlideTransition),
  ];
}
